//
//  URIParsedResult.h
//  ZXing
//
//  Created by Christian Brunschen on 29/05/2008.
/*
 * Copyright 2008 ZXing authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#import <UIKit/UIKit.h>
#import "ParsedResult.h"

@interface NSString (ZXingURLExtensions)
- (bool) looksLikeAURI;
- (NSString *)massagedURLString;
@end

@interface URIParsedResult : ParsedResult {
  NSString *urlString;
  NSString *title;
  NSURL *URL;
}

- initWithURLString:(NSString *)s title:(NSString *)t URL:(NSURL *)ur;
- initWithURLString:(NSString *)s title:(NSString *)t;
- initWithURLString:(NSString *)s URL:(NSURL *)ur;
- initWithURLString:(NSString *)s;

@property (nonatomic, retain) NSString *urlString;
@property (nonatomic, retain) NSString *title;
@property (nonatomic, retain) NSURL *URL;

@end
